package CrumbleDeath
{
	function Armor::onDisabled(%data,%obj,%enabled)
	{
		parent::onDisabled(%data,%obj,%enabled);
		%model = fileName(%data.shapeFile);
		if(%model !$= "m.dts" || %obj.type $= "DeathLimb")
			return;
		%client = %obj.client;
		if(%client $= "")
			return;
		%pos = %obj.getPosition();
		serverPlay3d(brickbreaksound,%pos);
		schedule(50,0,crumbleDeathAnim,%obj);
		spawnDeathLimbs(%obj);
		spawnDeathLimbs(%obj,"left");
		spawnDeathLimbs(%obj,"right");
		%obj.isDeathCrumbled=1;
	}
	function Armor::onRemove(%data,%obj)
	{
		parent::onRemove(%data,%obj);
		if(isObject(%obj.pd))
			%obj.pd.delete();
		%obj.hideNode("ALL");
		%obj.unmount();
		%obj.isDeathCrumbled=0;
	}
	function crumbleDeathAnim(%obj)
	{
		%obj.setActionThread(root);
		%obj.playthread(3,root);
		%obj.schedule(50,stopthread,0);
		%obj.playthread(0,look); //crouch
		%obj.playthread(1,sit);

		//Node Hiding
		%obj.hideNode("pants");
		%obj.hideNode("skirtHip");

		%obj.hideNode("LShoe");
		%obj.hideNode("LPeg");
		%obj.hideNode("RShoe");
		%obj.hideNode("RPeg");

		%obj.hideNode("LArm");
		%obj.hideNode("LArmSlim");
		%obj.hideNode("LHand");
		%obj.hideNode("LHook");

		%obj.hideNode("RArm");
		%obj.hideNode("RArmSlim");
		%obj.hideNode("RHand");
		%obj.hideNode("RHook");
	}
	function spawnDeathLimbs(%obj,%side)
{
		%tra = %obj.getTransform();
		%vel = %obj.getVelocity();
		%vel = vectorAdd(%vel,"0 0 5");
		%fvec = %obj.getForwardVector();
		%lvec = getLeftVector(%obj);
		if(%side $= "left" || %side $= "right")
		{
			%pos = vectorAdd(%tra,vectorScale(%fvec,-2));
			%tra = %pos SPC getWords(%tra,3,6);
		}
		if(%side $= "left")
			%vel = vectorAdd(%vel,vectorScale(%lvec,2));
		if(%side $= "right")
			%vel = vectorAdd(%vel,vectorScale(%lvec,-2));
		if(%side $= "")
			%vel = vectorAdd(%vel,vectorScale(%fvec,2));

		%bot = new AIPlayer()
		{
			dataBlock = PlayerStandardArmor;
			type = DeathLimb;
		};MissionCleanup.add(%bot);
		%bot.setTransform(%tra);
		%bot.setVelocity(%vel);
		%bot.kill();
		if(%side $= "")
			%bot.playthread(3,death);
		else if(%side $= "right")
			%bot.playthread(3,crouch);
		else
		{
			%bot.playthread(3,sit);
			%bot.playthread(2,look);
		}

		%client = %obj.client;
		%client.player = %bot;
		%client.applyBodyParts();
		%client.applyBodyColors();
		%client.player = %obj;

		//Node Hiding
		%bot.hideNode("plume");
		%bot.hideNode("triPlume");
		%bot.hideNode("septPlume");
		%bot.hideNode("visor");
		%bot.hideNode("helmet");
		%bot.hideNode("pointyHelmet");
		%bot.hideNode("flareHelmet");
		%bot.hideNode("scoutHat");
		%bot.hideNode("bicorn");
		%bot.hideNode("copHat");
		%bot.hideNode("knitHat");

		%bot.hideNode("headSkin");

		%bot.hideNode("chest");
		%bot.hideNode("femchest");

		if(%side !$= "")
		{
			%bot.hideNode("pants");
			%bot.hideNode("skirtHip");

			%bot.hideNode("LShoe");
			%bot.hideNode("LPeg");
			%bot.hideNode("RShoe");
			%bot.hideNode("RPeg");
		}
		if(%side !$= "left")
		{
			%bot.hideNode("LArm");
			%bot.hideNode("LArmSlim");
			%bot.hideNode("LHand");
			%bot.hideNode("LHook");
		}
		if(%side !$= "right")
		{
			%bot.hideNode("RArm");
			%bot.hideNode("RArmSlim");
			%bot.hideNode("RHand");
			%bot.hideNode("RHook");
		}
			
		%bot.hideNode("armor");
		%bot.hideNode("bucket");
		%bot.hideNode("cape");
		%bot.hideNode("pack");
		%bot.hideNode("quiver");
		%bot.hideNode("tank");

		%bot.hideNode("epaulets");
		%bot.hideNode("epauletsRankA");
		%bot.hideNode("epauletsRankB");
		%bot.hideNode("epauletsRankC");
		%bot.hideNode("epauletsRankD");
		%bot.hideNode("ShoulderPads");
		%bot.hideNode("skirtTrimLeft");
		%bot.hideNode("skirtTrimRight");
	}
	//Vector Code
	function getLeftVector(%obj)
	{
		return vectorCross(%obj.getForwardVector(),%obj.getUpVector());
	}
};activatePackage(CrumbleDeath);